﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

// should have done this as MVVM then the viewmodel would have most of this code and INotifyPropertyChanged whould do all the work.
namespace GradientSweetSpotError
{
	public partial class MainPage : UserControl
	{

        public double CenterX { get; set; }
        public double CenterY { get; set; }

        public double GradientOriginX { get; set; }
        public double GradientOriginY { get; set; }

		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
            LayoutRoot.DataContext = this;
            CenterX = 20.051;
            CenterY = 200;
            GradientOriginX = 218;
            GradientOriginY = 200;
		}

        private bool InButtonClick = false;

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            InButtonClick = true;
            CenterX = 20.051;
            CenterY = 200;
            TargetEllipse.Center = new Point(CenterX, CenterY);
            GradientOriginX = 218;
            GradientOriginY = 200;
            TargetEllipse.GradientOrigin = new Point(GradientOriginX, GradientOriginY);
            TargetEllipse.MappingMode = BrushMappingMode.Absolute;
            TargetEllipse.RadiusX = 199.5;
            TargetEllipse.RadiusY = 199.5;
            TargetEllipse.SpreadMethod = GradientSpreadMethod.Reflect;
            TargetCompositeTransform.ScaleY = -1;
            TargetCompositeTransform.ScaleX = 1.0;
            DefaultMappingMode.IsChecked = true;
            DefaultSpreadMethod.IsChecked = true;
            CenterXSlider.Value = CenterX;
            CenterYSlider.Value = CenterY;
            GradientOriginXSlider.Value = GradientOriginX;
            GradientOriginYSlider.Value = GradientOriginY;
            InButtonClick = false;
        }

        private void RadioButton_Click(object sender, RoutedEventArgs e)
        {
            RadioButton rb = (RadioButton)sender;
            switch (rb.Content.ToString())
            {
                case "Pad": TargetEllipse.SpreadMethod = GradientSpreadMethod.Pad;
                    break;
                case "Reflect": TargetEllipse.SpreadMethod = GradientSpreadMethod.Reflect;
                    break;
                case "Repeat": TargetEllipse.SpreadMethod = GradientSpreadMethod.Repeat;
                    break;
                case "Absolute": TargetEllipse.MappingMode = BrushMappingMode.Absolute;
                    break;
                case "RelativeToBoundingBox": TargetEllipse.MappingMode = BrushMappingMode.RelativeToBoundingBox;
                    break;
                default:
                    break;
            }
        }

        private void GradientOriginXSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (InButtonClick) return;
            GradientOriginX = ((Slider)sender).Value;
            GradientOriginY = (GradientOriginYSlider == null) ? 200 : GradientOriginYSlider.Value;
            if (TargetEllipse!=null)
                TargetEllipse.GradientOrigin = new Point(GradientOriginX, GradientOriginY);
        }

        private void GradientOriginYSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (InButtonClick) return;
            GradientOriginX = (GradientOriginXSlider == null) ? 218 : GradientOriginXSlider.Value;
            GradientOriginY = ((Slider)sender).Value;
            if (TargetEllipse != null)
            TargetEllipse.GradientOrigin = new Point(GradientOriginX, GradientOriginY);
        }

        private void CenterXSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (InButtonClick) return;
            CenterX = ((Slider)sender).Value;
            CenterY = (CenterYSlider==null)?200.0: CenterYSlider.Value;
            if (TargetEllipse != null)
            TargetEllipse.Center = new Point(CenterX, CenterY);
        }

        private void CenterYSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (InButtonClick) return;
            CenterX = (CenterXSlider == null) ? 20.051 : CenterXSlider.Value;
            CenterY = ((Slider)sender).Value;
            if (TargetEllipse != null)
            TargetEllipse.Center = new Point(CenterX, CenterY);
        }

        private void GenerateResults_Click(object sender, RoutedEventArgs e)
        {
            results.Text = "<!-- The following Ellipse definition was generated by Gradient Sweet Spot -->" + "\n";
            results.Text += string.Format("<Ellipse Margin=\"0,0,0,0\" Height=\"400\" Stroke=\"Black\" Width=\"400\" RenderTransformOrigin=\"0.5,0.5\">\n");
            results.Text += string.Format("\t<Ellipse.Fill>\n");
            results.Text += string.Format("\t\t<RadialGradientBrush Center=\"{0},{1}\" GradientOrigin=\"{2},{3}\" SpreadMethod=\"{4}\" MappingMode=\"{5}\" RadiusY=\"{6}\" RadiusX=\"{7}\">\n", CenterX, CenterY, GradientOriginX, GradientOriginY, TargetEllipse.SpreadMethod, TargetEllipse.MappingMode, TargetEllipse.RadiusX, TargetEllipse.RadiusY);
            results.Text += string.Format("\t\t\t<RadialGradientBrush.RelativeTransform>\n");
            results.Text += string.Format("\t\t\t\t<CompositeTransform ScaleX=\"{0}\" ScaleY=\"{1}\"/>\n", TargetCompositeTransform.ScaleX, TargetCompositeTransform.ScaleY);
            results.Text += string.Format("\t\t\t</RadialGradientBrush.RelativeTransform>\n");
            results.Text += string.Format("\t\t\t<GradientStop Color=\"Red\" Offset=\"0\"/>\n");
            results.Text += string.Format("\t\t\t<GradientStop Color=\"Green\" Offset=\"0.5\"/>\n");
            results.Text += string.Format("\t\t\t<GradientStop Color=\"Blue\" Offset=\"1\"/>\n");
            results.Text += string.Format("\t\t</RadialGradientBrush>\n");
            results.Text += string.Format("\t</Ellipse.Fill>\n");
            results.Text += string.Format("</Ellipse>\n");
        }

	}
}